﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Text;
using System.Collections.ObjectModel;
using Infragistics.Controls.Menus;
using Infragistics.Controls.Grids;

namespace DragDropSilverlight
{
    public partial class MainPage : UserControl
    {
        ObservableCollection<Person> gridSource = new ObservableCollection<Person>();
        ObservableCollection<Person> treeSource = new ObservableCollection<Person>();

        public MainPage()
        {
            InitializeComponent();

            //generate some data
            for (int i = 0; i < 5; i++)
            {
                Person p = new Person();
                p.Name = "Person " + i.ToString();

                for (int j = 0; j < 5; j++)
                {
                    Person pp = new Person();
                    pp.Name = p.Name + " " + j.ToString();
                    p.Relatives.Add(pp);
                }
                treeSource.Add(p);
            }

            // bind controls
            xamTree1.ItemsSource = treeSource;
            xamTree1.DisplayMemberPath = "Name";
            xamGrid1.ItemsSource = gridSource;
        }

        private void DragSource_DragStart(object sender, Infragistics.DragDrop.DragDropStartEventArgs e)  //(object sender, Infragistics.Silverlight.DragDropStartEventArgs e)
        {
            TextBlock textBlock = e.DragSource as TextBlock;
            if (textBlock != null)
            {
                object data = textBlock.DataContext;
                e.Data = data;
            }
            else
            {
                System.Diagnostics.Debug.WriteLine("You are dragging a " + e.DragSource.ToString());
            }
            
        }

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e) //Infragistics.Silverlight.DropEventArgs e)
        {
            if (e.DropTarget is XamGrid)
            {
                gridSource.Add(e.Data as Person);
            }
            else
                if (e.DropTarget is XamTree)
                {
                    treeSource.Add(e.Data as Person);
                }
                else
                {
                    var droppedPerson = (e.DropTarget as FrameworkElement).DataContext as Person;

                    if (droppedPerson.Relatives == null)
                    {
                        droppedPerson.Relatives = new ObservableCollection<Person>();
                    }
                    droppedPerson.Relatives.Add(e.Data as Person);
                }
        }


    }

    public class Person
    {
        public string Name { get; set; }

        public ObservableCollection<Person> Relatives { get; set; }

        public Person()
        {
            this.Relatives = new ObservableCollection<Person>();
        }
    }
}
